
/***************************************************************************
*
*   Copyright (c) 1998, 1999 Timpanogas Research Group, Inc.
*   895 West Center Street
*   Orem, Utah  84057
*   jmerkey@timpanogas.com
*
*   This program is free software; you can redistribute it and/or modify it
*   under the terms of the GNU General Public License as published by the
*   Free Software Foundation, version 2, or any later version.
*
*   This program is distributed in the hope that it will be useful, but
*   WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   General Public License for more details.
*
*   You are free to modify and re-distribute this program in accordance
*   with the terms specified in the GNU Public License.  The copyright
*   contained in this code is required to be present in any derivative
*   works and you are required to provide the source code for this
*   program as part of any commercial or non-commercial distribution.
*   You are required to respect the rights of the Copyright holders
*   named within this code.
*
*   jmerkey@timpanogas.com and TRG, Inc. are the official maintainers of
*   this code.  You are encouraged to report any bugs, problems, fixes,
*   suggestions, and comments about this software to jmerkey@timpanogas.com
*   or linux-kernel@vger.rutgers.edu.  New releases, patches, bug fixes, and
*   technical documentation can be found at www.timpanogas.com.  TRG will
*   periodically post new releases of this software to www.timpanogas.com
*   that contain bug fixes and enhanced capabilities.
*
*   Original Authorship      :
*      source code written by Jeff V. Merkey, TRG, Inc.
*
*   Original Contributors    :
*      Jeff V. Merkey, TRG, Inc.
*      Darren Major, TRG, Inc.
*      Alan Cox, RedHat Software, Inc.
*
****************************************************************************
*
*
*   AUTHOR   :  Jeff V. Merkey (jmerkey@timpanogas.com)
*   FILE     :  GLOBALS.C
*   DESCRIP  :  FENRIS Global Code Variables
*   DATE     :  November 1, 1998
*
*
***************************************************************************/

#include "globals.h"

ULONG MajorVersion = 0, MinorVersion = 0, BuildVersion = 0;
ULONG exitFlag = 0;
ULONG consoleHandle = 0;
ULONG MaximumNumberOfVolumes = 0;
ULONG NumberOfVolumes = 0;
ULONG TotalDisks = 0;
ULONG TotalNWParts = 0;
ULONG MaximumDisks = 0;
ULONG MaximumNWParts = 0;

ULONG MemoryAllocated = 0;
ULONG MemoryFreed = 0;
ULONG MemoryInUse = 0;

ULONG PagedMemoryAllocated = 0;
ULONG PagedMemoryFreed = 0;
ULONG PagedMemoryInUse = 0;

NWDISK *SystemDisk[MAX_DISKS];
VOLUME *VolumeTable[MAX_VOLUMES];
ULONG VolumeMountedTable[MAX_VOLUMES];
ULONG InstanceCounter = 1;
BYTE *ZeroBuffer = 0;
ULONG (*RemirrorProcessPtr)(ULONG) = 0;

ULONG DataLRUActive = 0;
ULONG JournalLRUActive = 0;

LRU_HANDLE DataLRU;
LRU_HANDLE JournalLRU;

ULONG HOTFIX_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    HOTFIX_LOCATION_0, HOTFIX_LOCATION_1, HOTFIX_LOCATION_2,
    HOTFIX_LOCATION_3
};

ULONG MIRROR_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    MIRROR_LOCATION_0, MIRROR_LOCATION_1, MIRROR_LOCATION_2,
    MIRROR_LOCATION_3
};

ULONG VOLTABLE_TRACK_OFFSET[MULTI_TRACK_COUNT]=
{
    VOLUME_TABLE_LOCATION_0, VOLUME_TABLE_LOCATION_1, VOLUME_TABLE_LOCATION_2,
    VOLUME_TABLE_LOCATION_3
};

#if (LINUX)

ULONG DiskDevices[MAX_DISKS] =
{
    // IDE (hda - hdt)
    0x0300, 0x0340, 0x1600, 0x1640, 0x2100, 0x2140, 0x2200, 0x2240,
    0x3800, 0x3840, 0x3900, 0x3940, 0x5800, 0x5840, 0x5900, 0x5940,
    0x5A00, 0x5A40, 0x5B00, 0x5B40,

    // SCSI 0-15  (sda - sdp)
    0x0800, 0x0810, 0x0820, 0x0830, 0x0840, 0x0850, 0x0860, 0x0870,
    0x0880, 0x0890, 0x08a0, 0x08b0, 0x08c0, 0x08d0, 0x08e0, 0x08f0,

    // SCSI 16-31  (sdq - sdaf)
    0x4100, 0x4110, 0x4120, 0x4130, 0x4140, 0x4150, 0x4160, 0x4170,
    0x4180, 0x4190, 0x41a0, 0x41b0, 0x41c0, 0x41d0, 0x41e0, 0x41f0,

    // SCSI 32-47  (sdag - sdav)
    0x4200, 0x4210, 0x4220, 0x4230, 0x4240, 0x4250, 0x4260, 0x4270,
    0x4280, 0x4290, 0x42a0, 0x42b0, 0x42c0, 0x42d0, 0x42e0, 0x42f0,

    // SCSI 48-63  (sdaw - sdbl)
    0x4300, 0x4310, 0x4320, 0x4330, 0x4340, 0x4350, 0x4360, 0x4370,
    0x4380, 0x4390, 0x43a0, 0x43b0, 0x43c0, 0x43d0, 0x43e0, 0x43f0,

    // SCSI 64-79  (sdbm - sdcb)
    0x4400, 0x4410, 0x4420, 0x4430, 0x4440, 0x4450, 0x4460, 0x4470,
    0x4480, 0x4490, 0x44a0, 0x44b0, 0x44c0, 0x44d0, 0x44e0, 0x44f0,

    // SCSI 80-95  (sdcc - sdcr)
    0x4500, 0x4510, 0x4520, 0x4530, 0x4540, 0x4550, 0x4560, 0x4570,
    0x4580, 0x4590, 0x45a0, 0x45b0, 0x45c0, 0x45d0, 0x45e0, 0x45f0,

    // SCSI 96-111  (sdcs - sddh)
    0x4600, 0x4610, 0x4620, 0x4630, 0x4640, 0x4650, 0x4660, 0x4670,
    0x4680, 0x4690, 0x46a0, 0x46b0, 0x46c0, 0x46d0, 0x46e0, 0x46f0,

    // SCSI 112-127  (sddi - sddx)
    0x4700, 0x4710, 0x4720, 0x4730, 0x4740, 0x4750, 0x4760, 0x4770,
    0x4780, 0x4790, 0x47a0, 0x47b0, 0x47c0, 0x47d0, 0x47e0, 0x47f0,

    // MCA EDSI (eda, edb)
    0x2400, 0x2440,

    // metadisk groups
    0x0900, 0x0901, 0x0902, 0x0903, 0x0904, 0x0905, 0x0906, 0x0907,
    0x0908, 0x0909, 0x090a, 0x090b, 0x090c, 0x090d, 0x090e, 0x090f,

    // XT disks
    0x0D00, 0x0D40,

    // Acorn MFM disks
    0x1500, 0x1540,

    // Parallel Port ATA disks
    0x2F00, 0x2F01, 0x2F02, 0x2F03,

    // I2O 0-15  (hda - hdp)
    0x5000, 0x5010, 0x5020, 0x5030, 0x5040, 0x5050, 0x5060, 0x5070,
    0x5080, 0x5090, 0x50a0, 0x50b0, 0x50c0, 0x50d0, 0x50e0, 0x50f0,

    // I2O 16-31  (hdq - hdaf)
    0x5100, 0x5110, 0x5120, 0x5130, 0x5140, 0x5150, 0x5160, 0x5170,
    0x5180, 0x5190, 0x51a0, 0x51b0, 0x51c0, 0x51d0, 0x51e0, 0x51f0,

    // I2O 32-47  (hdag - hdav)
    0x5200, 0x5210, 0x5220, 0x5230, 0x5240, 0x5250, 0x5260, 0x5270,
    0x5280, 0x5290, 0x52a0, 0x52b0, 0x52c0, 0x52d0, 0x52e0, 0x52f0,

    // I2O 48-63  (hdaw - hdbl)
    0x5300, 0x5310, 0x5320, 0x5330, 0x5340, 0x5350, 0x5360, 0x5370,
    0x5380, 0x5390, 0x53a0, 0x53b0, 0x53c0, 0x53d0, 0x53e0, 0x53f0,

    // I2O 64-79  (hdbm - hdcb)
    0x5400, 0x5410, 0x5420, 0x5430, 0x5440, 0x5450, 0x5460, 0x5470,
    0x5480, 0x5490, 0x54a0, 0x54b0, 0x54c0, 0x54d0, 0x54e0, 0x54f0,

    // I2O 80-95  (hdcc - hdcr)
    0x5500, 0x5510, 0x5520, 0x5530, 0x5540, 0x5550, 0x5560, 0x5570,
    0x5580, 0x5590, 0x55a0, 0x55b0, 0x55c0, 0x55d0, 0x55e0, 0x55f0,

    // I2O 96-111  (hdcs - hddh)
    0x5600, 0x5610, 0x5620, 0x5630, 0x5640, 0x5650, 0x5660, 0x5670,
    0x5680, 0x5690, 0x56a0, 0x56b0, 0x56c0, 0x56d0, 0x56e0, 0x56f0,

    // I2O 112-127  (hddi - hddx)
    0x5700, 0x5710, 0x5720, 0x5730, 0x5740, 0x5750, 0x5760, 0x5770,
    0x5780, 0x5790, 0x57a0, 0x57b0, 0x57c0, 0x57d0, 0x57e0, 0x57f0,
    0x0000,

};

BYTE *PhysicalDiskNames[MAX_DISKS]=
{
    // IDE disks
    "/dev/hda", "/dev/hdb", "/dev/hdc", "/dev/hdd",
    "/dev/hde", "/dev/hdf", "/dev/hdg", "/dev/hdh",
    "/dev/hdi", "/dev/hdj", "/dev/hdk", "/dev/hdl",
    "/dev/hdm", "/dev/hdn", "/dev/hdo", "/dev/hdp",
    "/dev/hdq", "/dev/hdr", "/dev/hds", "/dev/hdt",

    // SCSI disks 0-15
    "/dev/sda", "/dev/sdb", "/dev/sdc", "/dev/sdd",
    "/dev/sde", "/dev/sdf", "/dev/sdg", "/dev/sdh",
    "/dev/sdi", "/dev/sdj", "/dev/sdk", "/dev/sdl",
    "/dev/sdm", "/dev/sdn", "/dev/sdo", "/dev/sdp",

    // SCSI disks 15-31
    "/dev/sdq", "/dev/sdr", "/dev/sds", "/dev/sdt",
    "/dev/sdu", "/dev/sdv", "/dev/sdw", "/dev/sdx",
    "/dev/sdy", "/dev/sdz", "/dev/sdaa", "/dev/sdab",
    "/dev/sdac", "/dev/sdad", "/dev/sdae", "/dev/sdaf",

    // SCSI disks 32-47
    "/dev/sdag", "/dev/sdah", "/dev/sdai", "/dev/sdaj",
    "/dev/sdak", "/dev/sdal", "/dev/sdam", "/dev/sdan",
    "/dev/sdao", "/dev/sdap", "/dev/sdaq", "/dev/sdar",
    "/dev/sdas", "/dev/sdat", "/dev/sdau", "/dev/sdav",

    // SCSI disks 48-63
    "/dev/sdaw", "/dev/sdax", "/dev/sday", "/dev/sdaz",
    "/dev/sdba", "/dev/sdbb", "/dev/sdbc", "/dev/sdbd",
    "/dev/sdbe", "/dev/sdbf", "/dev/sdbg", "/dev/sdbh",
    "/dev/sdbi", "/dev/sdbj", "/dev/sdbk", "/dev/sdbl",

    // SCSI disks 64-79
    "/dev/sdbm", "/dev/sdbn", "/dev/sdbo", "/dev/sdbp",
    "/dev/sdbq", "/dev/sdbr", "/dev/sdbs", "/dev/sdbt",
    "/dev/sdbu", "/dev/sdbv", "/dev/sdbw", "/dev/sdbx",
    "/dev/sdby", "/dev/sdbz", "/dev/sdca", "/dev/sdcb",

    // SCSI disks 80-95
    "/dev/sdcc", "/dev/sdcd", "/dev/sdce", "/dev/sdcf",
    "/dev/sdcg", "/dev/sdch", "/dev/sdci", "/dev/sdcj",
    "/dev/sdck", "/dev/sdcl", "/dev/sdcm", "/dev/sdcn",
    "/dev/sdco", "/dev/sdcp", "/dev/sdcq", "/dev/sdcr",

    // SCSI disks 96-111
    "/dev/sdcs", "/dev/sdct", "/dev/sdcu", "/dev/sdcv",
    "/dev/sdcw", "/dev/sdcx", "/dev/sdcy", "/dev/sdcz",
    "/dev/sdda", "/dev/sddb", "/dev/sddc", "/dev/sddd",
    "/dev/sdde", "/dev/sddf", "/dev/sddg", "/dev/sddh",

    // SCSI disks 112-127
    "/dev/sddi", "/dev/sddj", "/dev/sddk", "/dev/sddl",
    "/dev/sddm", "/dev/sddn", "/dev/sddo", "/dev/sddp",
    "/dev/sddq", "/dev/sddr", "/dev/sdds", "/dev/sddt",
    "/dev/sddu", "/dev/sddv", "/dev/sddw", "/dev/sddx",

    // MCA ESDI disks
    "/dev/eda", "/dev/edb",

    // metadisk groups
    "/dev/md0", "dev/md1", "/dev/md2", "dev/md3",
    "/dev/md4", "dev/md5", "/dev/md6", "dev/md7",
    "/dev/md8", "dev/md9", "/dev/md10", "dev/md11",
    "/dev/md12", "dev/md13", "/dev/md14", "dev/md15",

    // XT disks
    "/dev/xda", "/dev/xdb",

    // Acorn MFM disks
    "/dev/mfma", "/dev/mfmb",

    // Parallel Port ATA disks
    "/dev/pf0", "/dev/pf1", "/dev/pf2", "/dev/pf3",

    // I2O disks 0-15
    "/dev/i2o/hda", "/dev/i2o/hdb", "/dev/i2o/hdc", "/dev/i2o/hdd",
    "/dev/i2o/hde", "/dev/i2o/hdf", "/dev/i2o/hdg", "/dev/i2o/hdh",
    "/dev/i2o/hdi", "/dev/i2o/hdj", "/dev/i2o/hdk", "/dev/i2o/hdl",
    "/dev/i2o/hdm", "/dev/i2o/hdn", "/dev/i2o/hdo", "/dev/i2o/hdp",

    // I2O disks 16-31
    "/dev/i2o/hdq", "/dev/i2o/hdr", "/dev/i2o/hds", "/dev/i2o/hdt",
    "/dev/i2o/hdu", "/dev/i2o/hdv", "/dev/i2o/hdw", "/dev/i2o/hdx",
    "/dev/i2o/hdy", "/dev/i2o/hdz", "/dev/i2o/hdaa", "/dev/i2o/hdab",
    "/dev/i2o/hdac", "/dev/i2o/hdad", "/dev/i2o/hdae", "/dev/i2o/hdaf",

    // I2O disks 32-47
    "/dev/i2o/hdag", "/dev/i2o/hdah", "/dev/i2o/hdai", "/dev/i2o/hdaj",
    "/dev/i2o/hdak", "/dev/i2o/hdal", "/dev/i2o/hdam", "/dev/i2o/hdan",
    "/dev/i2o/hdao", "/dev/i2o/hdap", "/dev/i2o/hdaq", "/dev/i2o/hdar",
    "/dev/i2o/hdas", "/dev/i2o/hdat", "/dev/i2o/hdau", "/dev/i2o/hdav",

    // I2O disks 48-63
    "/dev/i2o/hdaw", "/dev/i2o/hdax", "/dev/i2o/hday", "/dev/i2o/hdaz",
    "/dev/i2o/hdba", "/dev/i2o/hdbb", "/dev/i2o/hdbc", "/dev/i2o/hdbd",
    "/dev/i2o/hdbe", "/dev/i2o/hdbf", "/dev/i2o/hdbg", "/dev/i2o/hdbh",
    "/dev/i2o/hdbi", "/dev/i2o/hdbj", "/dev/i2o/hdbk", "/dev/i2o/hdbl",

    // I2O disks 64-79
    "/dev/i2o/hdbm", "/dev/i2o/hdbn", "/dev/i2o/hdbo", "/dev/i2o/hdbp",
    "/dev/i2o/hdbq", "/dev/i2o/hdbr", "/dev/i2o/hdbs", "/dev/i2o/hdbt",
    "/dev/i2o/hdbu", "/dev/i2o/hdbv", "/dev/i2o/hdbw", "/dev/i2o/hdbx",
    "/dev/i2o/hdby", "/dev/i2o/hdbz", "/dev/i2o/hdca", "/dev/i2o/hdcb",

    // I2O disks 80-95
    "/dev/i2o/hdcc", "/dev/i2o/hdcd", "/dev/i2o/hdce", "/dev/i2o/hdcf",
    "/dev/i2o/hdcg", "/dev/i2o/hdch", "/dev/i2o/hdci", "/dev/i2o/hdcj",
    "/dev/i2o/hdck", "/dev/i2o/hdcl", "/dev/i2o/hdcm", "/dev/i2o/hdcn",
    "/dev/i2o/hdco", "/dev/i2o/hdcp", "/dev/i2o/hdcq", "/dev/i2o/hdcr",

    // I2O disks 96-111
    "/dev/i2o/hdcs", "/dev/i2o/hdct", "/dev/i2o/hdcu", "/dev/i2o/hdcv",
    "/dev/i2o/hdcw", "/dev/i2o/hdcx", "/dev/i2o/hdcy", "/dev/i2o/hdcz",
    "/dev/i2o/hdda", "/dev/i2o/hddb", "/dev/i2o/hddc", "/dev/i2o/hddd",
    "/dev/i2o/hdde", "/dev/i2o/hddf", "/dev/i2o/hddg", "/dev/i2o/hddh",

    // I2O disks 112-127
    "/dev/i2o/hddi", "/dev/i2o/hddj", "/dev/i2o/hddk", "/dev/i2o/hddl",
    "/dev/i2o/hddm", "/dev/i2o/hddn", "/dev/i2o/hddo", "/dev/i2o/hddp",
    "/dev/i2o/hddq", "/dev/i2o/hddr", "/dev/i2o/hdds", "/dev/i2o/hddt",
    "/dev/i2o/hddu", "/dev/i2o/hddv", "/dev/i2o/hddw", "/dev/i2o/hddx",
    NULL,

};

ULONG MaxDisksSupported = sizeof(DiskDevices) / sizeof(ULONG);
ULONG MaxHandlesSupported = sizeof(PhysicalDiskNames) / sizeof(BYTE *);

#endif

void InitNWFS(void)
{
    register ULONG ccode, i;
    extern ASYNCH_IO_HEAD asynch_io_head[MAX_DISKS];
#if (LINUX_SPIN)
    extern spinlock_t aio_spinlock;
    extern spinlock_t cb_spinlock;
    extern spinlock_t bh_spinlock;
#endif

    ccode = InitializeLRU(&DataLRU, "Data LRU", WRITE_BACK_LRU,
			  MAX_VOLUME_LRU_BLOCKS,
			  MIN_VOLUME_LRU_BLOCKS);
    if (!ccode)
       DataLRUActive = TRUE;

    ccode = InitializeLRU(&JournalLRU, "Journal LRU", WRITE_BACK_LRU,
			  MAX_DIRECTORY_LRU_BLOCKS,
			  MIN_DIRECTORY_LRU_BLOCKS);
    if (!ccode)
       JournalLRUActive = TRUE;

    ZeroBuffer = NWFSIOAlloc(65536, DISKBUF_TAG);
    if (!ZeroBuffer)
       return;
    NWFSSet(ZeroBuffer, 0, 65536);

    // initialize the asynch io avl heads
    for (i=0; i < MAX_DISKS; i++)
       NWFSSet(&asynch_io_head[i], 0, sizeof(ASYNCH_IO_HEAD));

#if (LINUX_SPIN)
    spin_lock_init(&aio_spinlock);
    spin_lock_init(&cb_spinlock);
    spin_lock_init(&bh_spinlock);
#endif

    return;
}

